from enum import Enum
from plum import dispatch
from typing import TypeVar,Union,Generic,List,Tuple
from spire.presentation.common import *
from spire.presentation import *
from ctypes import *
import abc

class AnimationEffectType(Enum):
    """
    <summary>
        Represents an animation effect type
    </summary>
    """
    Appear = 0
    ArcUp = 1
    Ascend = 2
    Blast = 3
    Blinds = 4
    Blink = 5
    BoldFlash = 6
    BoldReveal = 7
    Boomerang = 8
    Bounce = 9
    Box = 10
    BrushOnColor = 11
    BrushOnUnderline = 12
    CenterRevolve = 13
    ChangeFillColor = 14
    ChangeFont = 15
    ChangeFontColor = 16
    ChangeFontSize = 17
    ChangeFontStyle = 18
    ChangeLineColor = 19
    Checkerboard = 20
    Circle = 21
    ColorBlend = 22
    ColorReveal = 23
    ColorWave = 24
    ComplementaryColor = 25
    ComplementaryColor2 = 26
    Compress = 27
    ContrastingColor = 28
    Crawl = 29
    Credits = 30
    Darken = 31
    Desaturate = 32
    Descend = 33
    Diamond = 34
    Dissolve = 35
    EaseIn = 36
    Expand = 37
    Fade = 38
    FadedSwivel = 39
    FadedZoom = 40
    FlashBulb = 41
    FlashOnce = 42
    Flicker = 43
    Flip = 44
    Float = 45
    Fly = 46
    Fold = 47
    Glide = 48
    GrowAndTurn = 49
    GrowShrink = 50
    GrowWithColor = 51
    Lighten = 52
    LightSpeed = 53
    MediaPause = 54
    MediaPlay = 55
    MediaStop = 56
    Path4PointStar = 57
    Path5PointStar = 58
    Path6PointStar = 59
    Path8PointStar = 60
    PathArcDown = 61
    PathArcLeft = 62
    PathArcRight = 63
    PathArcUp = 64
    PathBean = 65
    PathBounceLeft = 66
    PathBounceRight = 67
    PathBuzzsaw = 68
    PathCircle = 69
    PathCrescentMoon = 70
    PathCurvedSquare = 71
    PathCurvedX = 72
    PathCurvyLeft = 73
    PathCurvyRight = 74
    PathCurvyStar = 75
    PathDecayingWave = 76
    PathDiagonalDownRight = 77
    PathDiagonalUpRight = 78
    PathDiamond = 79
    PathDown = 80
    PathEqualTriangle = 81
    PathFigure8Four = 82
    PathFootball = 83
    PathFunnel = 84
    PathHeart = 85
    PathHeartbeat = 86
    PathHexagon = 87
    PathHorizontalFigure8 = 88
    PathInvertedSquare = 89
    PathInvertedTriangle = 90
    PathLeft = 91
    PathLoopdeLoop = 92
    PathNeutron = 93
    PathOctagon = 94
    PathParallelogram = 95
    PathPeanut = 96
    PathPentagon = 97
    PathPlus = 98
    PathPointyStar = 99
    PathRight = 100
    PathRightTriangle = 101
    PathSCurve1 = 102
    PathSCurve2 = 103
    PathSineWave = 104
    PathSpiralLeft = 105
    PathSpiralRight = 106
    PathSpring = 107
    PathSquare = 108
    PathStairsDown = 109
    PathSwoosh = 110
    PathTeardrop = 111
    PathTrapezoid = 112
    PathTurnDown = 113
    PathTurnRight = 114
    PathTurnUp = 115
    PathTurnUpRight = 116
    PathUp = 117
    PathUser = 118
    PathVerticalFigure8 = 119
    PathWave = 120
    PathZigzag = 121
    Peek = 122
    Pinwheel = 123
    Plus = 124
    RandomBars = 125
    RandomEffects = 126
    RiseUp = 127
    Shimmer = 128
    Sling = 129
    Spin = 130
    Spinner = 131
    Spiral = 132
    Split = 133
    Stretch = 134
    Strips = 135
    StyleEmphasis = 136
    Swish = 137
    Swivel = 138
    Teeter = 139
    Thread = 140
    Transparency = 141
    Unfold = 142
    VerticalGrow = 143
    Wave = 144
    Wedge = 145
    Wheel = 146
    Whip = 147
    Wipe = 148
    Magnify = 149
    Zoom = 150

