from enum import Enum
from plum import dispatch
from typing import TypeVar,Union,Generic,List,Tuple
from spire.presentation.common import *
from spire.presentation import *
from ctypes import *
import abc

class GradientStop (SpireObject) :
    """
    <summary>
        Represents a gradient stop.
    </summary>
    """
    @property
    def Position(self)->float:
        """
    <summary>
        Gets or sets the position (0..1) of a gradient stop.
            Read/write <see cref="T:System.Single" />.
    </summary>
        """
        GetDllLibPpt().GradientStop_get_Position.argtypes=[c_void_p]
        GetDllLibPpt().GradientStop_get_Position.restype=c_float
        ret = GetDllLibPpt().GradientStop_get_Position(self.Ptr)
        return ret

    @Position.setter
    def Position(self, value:float):
        GetDllLibPpt().GradientStop_set_Position.argtypes=[c_void_p, c_float]
        GetDllLibPpt().GradientStop_set_Position(self.Ptr, value)

    @property

    def Color(self)->'ColorFormat':
        """
    <summary>
        Gets the color of a gradient stop.
            Read-only <see cref="T:Spire.Presentation.Drawing.ColorFormat" />.
    </summary>
        """
        GetDllLibPpt().GradientStop_get_Color.argtypes=[c_void_p]
        GetDllLibPpt().GradientStop_get_Color.restype=c_void_p
        intPtr = GetDllLibPpt().GradientStop_get_Color(self.Ptr)
        ret = None if intPtr==None else ColorFormat(intPtr)
        return ret


