from enum import Enum
from plum import dispatch
from typing import TypeVar,Union,Generic,List,Tuple
from spire.presentation.common import *
from spire.presentation import *
from ctypes import *
import abc

class IDocumentProperty (SpireObject) :
    """

    """
    @property

    def Application(self)->str:
        """
    <summary>
        Gets or sets the name of the application.
            Read/write <see cref="T:System.String" />.
    </summary>
        """
        GetDllLibPpt().IDocumentProperty_get_Application.argtypes=[c_void_p]
        GetDllLibPpt().IDocumentProperty_get_Application.restype=c_void_p
        ret = PtrToStr(GetDllLibPpt().IDocumentProperty_get_Application(self.Ptr))
        return ret


    @Application.setter
    def Application(self, value:str):
        valuePtr = StrToPtr(value)
        GetDllLibPpt().IDocumentProperty_set_Application.argtypes=[c_void_p, c_char_p]
        GetDllLibPpt().IDocumentProperty_set_Application(self.Ptr,valuePtr)


    @property

    def MarkAsFinal(self)->bool:
        """
    <summary>
        Gets or sets the name of the application.
            Read/write <see cref="T:System.String" />.
    </summary>
        """
        GetDllLibPpt().IDocumentProperty_IsMarkAsFinal.argtypes=[c_void_p]
        GetDllLibPpt().IDocumentProperty_IsMarkAsFinal.restype= c_bool
        ret = GetDllLibPpt().IDocumentProperty_IsMarkAsFinal(self.Ptr)
        return ret


    @MarkAsFinal.setter
    def MarkAsFinal(self, value:bool):
        GetDllLibPpt().IDocumentProperty_MarkAsFinal.argtypes=[c_void_p, c_bool]
        GetDllLibPpt().IDocumentProperty_MarkAsFinal(self.Ptr, value)


    @property

    def Company(self)->str:
        """
    <summary>
        Gets or sets the company property.
            Read/write <see cref="T:System.String" />.
    </summary>
        """
        GetDllLibPpt().IDocumentProperty_get_Company.argtypes=[c_void_p]
        GetDllLibPpt().IDocumentProperty_get_Company.restype=c_void_p
        ret = PtrToStr(GetDllLibPpt().IDocumentProperty_get_Company(self.Ptr))
        return ret


    @Company.setter
    def Company(self, value:str):
        valuePtr = StrToPtr(value)
        GetDllLibPpt().IDocumentProperty_set_Company.argtypes=[c_void_p, c_char_p]
        GetDllLibPpt().IDocumentProperty_set_Company(self.Ptr,valuePtr)

    @property

    def Manager(self)->str:
        """
    <summary>
        Gets or sets the manager property.
            Read/write <see cref="T:System.String" />.
    </summary>
        """
        GetDllLibPpt().IDocumentProperty_get_Manager.argtypes=[c_void_p]
        GetDllLibPpt().IDocumentProperty_get_Manager.restype=c_void_p
        ret = PtrToStr(GetDllLibPpt().IDocumentProperty_get_Manager(self.Ptr))
        return ret


    @Manager.setter
    def Manager(self, value:str):
        valuePtr = StrToPtr(value)
        GetDllLibPpt().IDocumentProperty_set_Manager.argtypes=[c_void_p, c_char_p]
        GetDllLibPpt().IDocumentProperty_set_Manager(self.Ptr,valuePtr)

    @property

    def Format(self)->str:
        """
    <summary>
        Gets or sets the intended format of a presentation.
            Read/write <see cref="T:System.String" />.
    </summary>
        """
        GetDllLibPpt().IDocumentProperty_get_Format.argtypes=[c_void_p]
        GetDllLibPpt().IDocumentProperty_get_Format.restype=c_void_p
        ret = PtrToStr(GetDllLibPpt().IDocumentProperty_get_Format(self.Ptr))
        return ret


    @Format.setter
    def Format(self, value:str):
        valuePtr = StrToPtr(value)
        GetDllLibPpt().IDocumentProperty_set_Format.argtypes=[c_void_p, c_char_p]
        GetDllLibPpt().IDocumentProperty_set_Format(self.Ptr,valuePtr)

    @property
    def SharedDoc(self)->bool:
        """
    <summary>
        Indicates whether the presentation is shared between multiple people.
            Read/write <see cref="T:System.Boolean" />.
    </summary>
        """
        GetDllLibPpt().IDocumentProperty_get_SharedDoc.argtypes=[c_void_p]
        GetDllLibPpt().IDocumentProperty_get_SharedDoc.restype=c_bool
        ret = GetDllLibPpt().IDocumentProperty_get_SharedDoc(self.Ptr)
        return ret

    @SharedDoc.setter
    def SharedDoc(self, value:bool):
        GetDllLibPpt().IDocumentProperty_set_SharedDoc.argtypes=[c_void_p, c_bool]
        GetDllLibPpt().IDocumentProperty_set_SharedDoc(self.Ptr, value)

    @property

    def Template(self)->str:
        """
    <summary>
        Gets or sets the template of a application.
            Read/write <see cref="T:System.String" />.
    </summary>
        """
        GetDllLibPpt().IDocumentProperty_get_Template.argtypes=[c_void_p]
        GetDllLibPpt().IDocumentProperty_get_Template.restype=c_void_p
        ret = PtrToStr(GetDllLibPpt().IDocumentProperty_get_Template(self.Ptr))
        return ret


    @Template.setter
    def Template(self, value:str):
        valuePtr = StrToPtr(value)
        GetDllLibPpt().IDocumentProperty_set_Template.argtypes=[c_void_p, c_char_p]
        GetDllLibPpt().IDocumentProperty_set_Template(self.Ptr,valuePtr)

    @property

    def TotalEditingTime(self)->'TimeSpan':
        """
    <summary>
        Total editing time of a presentation.
            Read/write <see cref="T:System.TimeSpan" />.
    </summary>
        """
        GetDllLibPpt().IDocumentProperty_get_TotalEditingTime.argtypes=[c_void_p]
        GetDllLibPpt().IDocumentProperty_get_TotalEditingTime.restype=c_void_p
        intPtr = GetDllLibPpt().IDocumentProperty_get_TotalEditingTime(self.Ptr)
        ret = None if intPtr==None else TimeSpan(intPtr)
        return ret


    @TotalEditingTime.setter
    def TotalEditingTime(self, value:'TimeSpan'):
        GetDllLibPpt().IDocumentProperty_set_TotalEditingTime.argtypes=[c_void_p, c_void_p]
        GetDllLibPpt().IDocumentProperty_set_TotalEditingTime(self.Ptr, value.Ptr)

    @property

    def Title(self)->str:
        """
    <summary>
        Gets or sets the title of a presentation.
            Read/write <see cref="T:System.String" />.
    </summary>
        """
        GetDllLibPpt().IDocumentProperty_get_Title.argtypes=[c_void_p]
        GetDllLibPpt().IDocumentProperty_get_Title.restype=c_void_p
        ret = PtrToStr(GetDllLibPpt().IDocumentProperty_get_Title(self.Ptr))
        return ret


    @Title.setter
    def Title(self, value:str):
        valuePtr = StrToPtr(value)
        GetDllLibPpt().IDocumentProperty_set_Title.argtypes=[c_void_p, c_char_p]
        GetDllLibPpt().IDocumentProperty_set_Title(self.Ptr,valuePtr)

    @property

    def Subject(self)->str:
        """
    <summary>
        Gets or sets the subject of a presentation.
            Read/write <see cref="T:System.String" />.
    </summary>
        """
        GetDllLibPpt().IDocumentProperty_get_Subject.argtypes=[c_void_p]
        GetDllLibPpt().IDocumentProperty_get_Subject.restype=c_void_p
        ret = PtrToStr(GetDllLibPpt().IDocumentProperty_get_Subject(self.Ptr))
        return ret


    @Subject.setter
    def Subject(self, value:str):
        valuePtr = StrToPtr(value)
        GetDllLibPpt().IDocumentProperty_set_Subject.argtypes=[c_void_p, c_char_p]
        GetDllLibPpt().IDocumentProperty_set_Subject(self.Ptr,valuePtr)

    @property

    def Author(self)->str:
        """
    <summary>
        Gets or sets the author of a presentation.
            Read/write <see cref="T:System.String" />.
    </summary>
        """
        GetDllLibPpt().IDocumentProperty_get_Author.argtypes=[c_void_p]
        GetDllLibPpt().IDocumentProperty_get_Author.restype=c_void_p
        ret = PtrToStr(GetDllLibPpt().IDocumentProperty_get_Author(self.Ptr))
        return ret


    @Author.setter
    def Author(self, value:str):
        valuePtr = StrToPtr(value)
        GetDllLibPpt().IDocumentProperty_set_Author.argtypes=[c_void_p, c_char_p]
        GetDllLibPpt().IDocumentProperty_set_Author(self.Ptr,valuePtr)

    @property

    def Keywords(self)->str:
        """
    <summary>
        Gets or sets the keywords of a presentation.
            Read/write <see cref="T:System.String" />.
    </summary>
        """
        GetDllLibPpt().IDocumentProperty_get_Keywords.argtypes=[c_void_p]
        GetDllLibPpt().IDocumentProperty_get_Keywords.restype=c_void_p
        ret = PtrToStr(GetDllLibPpt().IDocumentProperty_get_Keywords(self.Ptr))
        return ret


    @Keywords.setter
    def Keywords(self, value:str):
        valuePtr = StrToPtr(value)
        GetDllLibPpt().IDocumentProperty_set_Keywords.argtypes=[c_void_p, c_char_p]
        GetDllLibPpt().IDocumentProperty_set_Keywords(self.Ptr,valuePtr)

    @property

    def Comments(self)->str:
        """
    <summary>
        Gets or sets the comments of a presentation.
            Read/write <see cref="T:System.String" />.
    </summary>
        """
        GetDllLibPpt().IDocumentProperty_get_Comments.argtypes=[c_void_p]
        GetDllLibPpt().IDocumentProperty_get_Comments.restype=c_void_p
        ret = PtrToStr(GetDllLibPpt().IDocumentProperty_get_Comments(self.Ptr))
        return ret


    @Comments.setter
    def Comments(self, value:str):
        valuePtr = StrToPtr(value)
        GetDllLibPpt().IDocumentProperty_set_Comments.argtypes=[c_void_p, c_char_p]
        GetDllLibPpt().IDocumentProperty_set_Comments(self.Ptr,valuePtr)

    @property

    def Category(self)->str:
        """
    <summary>
        Gets or sets the category of a presentation.
            Read/write <see cref="T:System.String" />.
    </summary>
        """
        GetDllLibPpt().IDocumentProperty_get_Category.argtypes=[c_void_p]
        GetDllLibPpt().IDocumentProperty_get_Category.restype=c_void_p
        ret = PtrToStr(GetDllLibPpt().IDocumentProperty_get_Category(self.Ptr))
        return ret


    @Category.setter
    def Category(self, value:str):
        valuePtr = StrToPtr(value)
        GetDllLibPpt().IDocumentProperty_set_Category.argtypes=[c_void_p, c_char_p]
        GetDllLibPpt().IDocumentProperty_set_Category(self.Ptr,valuePtr)

    @property

    def CreatedTime(self)->'DateTime':
        """
    <summary>
        Gets or sets the date when a presentation was created.
            Read/write <see cref="T:System.DateTime" />.
    </summary>
        """
        GetDllLibPpt().IDocumentProperty_get_CreatedTime.argtypes=[c_void_p]
        GetDllLibPpt().IDocumentProperty_get_CreatedTime.restype=c_void_p
        intPtr = GetDllLibPpt().IDocumentProperty_get_CreatedTime(self.Ptr)
        ret = None if intPtr==None else DateTime(intPtr)
        return ret


    @CreatedTime.setter
    def CreatedTime(self, value:'DateTime'):
        GetDllLibPpt().IDocumentProperty_set_CreatedTime.argtypes=[c_void_p, c_void_p]
        GetDllLibPpt().IDocumentProperty_set_CreatedTime(self.Ptr, value.Ptr)

    @property

    def LastSavedTime(self)->'DateTime':
        """
    <summary>
        Gets or sets the date when a presentation was modified last time.
            Read/write <see cref="T:System.DateTime" />.
    </summary>
        """
        GetDllLibPpt().IDocumentProperty_get_LastSavedTime.argtypes=[c_void_p]
        GetDllLibPpt().IDocumentProperty_get_LastSavedTime.restype=c_void_p
        intPtr = GetDllLibPpt().IDocumentProperty_get_LastSavedTime(self.Ptr)
        ret = None if intPtr==None else DateTime(intPtr)
        return ret


    @LastSavedTime.setter
    def LastSavedTime(self, value:'DateTime'):
        GetDllLibPpt().IDocumentProperty_set_LastSavedTime.argtypes=[c_void_p, c_void_p]
        GetDllLibPpt().IDocumentProperty_set_LastSavedTime(self.Ptr, value.Ptr)

    @property

    def LastPrinted(self)->'DateTime':
        """
    <summary>
        Gets or sets the date when a presentation was printed last time.
            Read/write <see cref="T:System.DateTime" />.
    </summary>
        """
        GetDllLibPpt().IDocumentProperty_get_LastPrinted.argtypes=[c_void_p]
        GetDllLibPpt().IDocumentProperty_get_LastPrinted.restype=c_void_p
        intPtr = GetDllLibPpt().IDocumentProperty_get_LastPrinted(self.Ptr)
        ret = None if intPtr==None else DateTime(intPtr)
        return ret


    @LastPrinted.setter
    def LastPrinted(self, value:'DateTime'):
        GetDllLibPpt().IDocumentProperty_set_LastPrinted.argtypes=[c_void_p, c_void_p]
        GetDllLibPpt().IDocumentProperty_set_LastPrinted(self.Ptr, value.Ptr)

    @property

    def LastSavedBy(self)->str:
        """
    <summary>
        Gets or sets the name of a last person who modified a presentation.
            Read/write <see cref="T:System.String" />.
    </summary>
        """
        GetDllLibPpt().IDocumentProperty_get_LastSavedBy.argtypes=[c_void_p]
        GetDllLibPpt().IDocumentProperty_get_LastSavedBy.restype=c_void_p
        ret = PtrToStr(GetDllLibPpt().IDocumentProperty_get_LastSavedBy(self.Ptr))
        return ret


    @LastSavedBy.setter
    def LastSavedBy(self, value:str):
        valuePtr = StrToPtr(value)
        GetDllLibPpt().IDocumentProperty_set_LastSavedBy.argtypes=[c_void_p, c_char_p]
        GetDllLibPpt().IDocumentProperty_set_LastSavedBy(self.Ptr,valuePtr)

    @property
    def RevisionNumber(self)->int:
        """
    <summary>
        Gets or sets the presentation revision number.
            Read/write <see cref="T:System.Int32" />.
    </summary>
        """
        GetDllLibPpt().IDocumentProperty_get_RevisionNumber.argtypes=[c_void_p]
        GetDllLibPpt().IDocumentProperty_get_RevisionNumber.restype=c_int
        ret = GetDllLibPpt().IDocumentProperty_get_RevisionNumber(self.Ptr)
        return ret

    @RevisionNumber.setter
    def RevisionNumber(self, value:int):
        GetDllLibPpt().IDocumentProperty_set_RevisionNumber.argtypes=[c_void_p, c_int]
        GetDllLibPpt().IDocumentProperty_set_RevisionNumber(self.Ptr, value)

    @property

    def ContentStatus(self)->str:
        """
    <summary>
        Gets or sets the content status of a presentation.
            Read/write <see cref="T:System.String" />.
    </summary>
        """
        GetDllLibPpt().IDocumentProperty_get_ContentStatus.argtypes=[c_void_p]
        GetDllLibPpt().IDocumentProperty_get_ContentStatus.restype=c_void_p
        ret = PtrToStr(GetDllLibPpt().IDocumentProperty_get_ContentStatus(self.Ptr))
        return ret


    @ContentStatus.setter
    def ContentStatus(self, value:str):
        valuePtr = StrToPtr(value)
        GetDllLibPpt().IDocumentProperty_set_ContentStatus.argtypes=[c_void_p, c_char_p]
        GetDllLibPpt().IDocumentProperty_set_ContentStatus(self.Ptr,valuePtr)

    @property

    def ContentType(self)->str:
        """
    <summary>
        Gets or sets the content type of a presentation.
            Read/write <see cref="T:System.String" />.
    </summary>
        """
        GetDllLibPpt().IDocumentProperty_get_ContentType.argtypes=[c_void_p]
        GetDllLibPpt().IDocumentProperty_get_ContentType.restype=c_void_p
        ret = PtrToStr(GetDllLibPpt().IDocumentProperty_get_ContentType(self.Ptr))
        return ret


    @ContentType.setter
    def ContentType(self, value:str):
        valuePtr = StrToPtr(value)
        GetDllLibPpt().IDocumentProperty_set_ContentType.argtypes=[c_void_p, c_char_p]
        GetDllLibPpt().IDocumentProperty_set_ContentType(self.Ptr,valuePtr)

    @property
    def Count(self)->int:
        """
    <summary>
        Gets the number of custom properties actually contained in a collection.
            Read-only <see cref="T:System.Int32" />.
    </summary>
        """
        GetDllLibPpt().IDocumentProperty_get_Count.argtypes=[c_void_p]
        GetDllLibPpt().IDocumentProperty_get_Count.restype=c_int
        ret = GetDllLibPpt().IDocumentProperty_get_Count(self.Ptr)
        return ret

    @property

    def HyperlinkBase(self)->str:
        """
    <summary>
        Gets or sets the HyperlinkBase document property.
    </summary>
        """
        GetDllLibPpt().IDocumentProperty_get_HyperlinkBase.argtypes=[c_void_p]
        GetDllLibPpt().IDocumentProperty_get_HyperlinkBase.restype=c_void_p
        ret = PtrToStr(GetDllLibPpt().IDocumentProperty_get_HyperlinkBase(self.Ptr))
        return ret


    @HyperlinkBase.setter
    def HyperlinkBase(self, value:str):
        valuePtr = StrToPtr(value)
        GetDllLibPpt().IDocumentProperty_set_HyperlinkBase.argtypes=[c_void_p, c_char_p]
        GetDllLibPpt().IDocumentProperty_set_HyperlinkBase(self.Ptr,valuePtr)


    def GetPropertyName(self ,index:int)->str:
        """
    <summary>
        Return a custom property name at the specified index.
    </summary>
    <param name="index">The zero-based index of a custom property to get.</param>
    <returns>Custom property name at the specified index.</returns>
<exception cref="T:System.ArgumentOutOfRangeException">Index is less than zero. Index is equal to or greater than Count.</exception>
        """
        
        GetDllLibPpt().IDocumentProperty_GetPropertyName.argtypes=[c_void_p ,c_int]
        GetDllLibPpt().IDocumentProperty_GetPropertyName.restype=c_void_p
        ret = PtrToStr(GetDllLibPpt().IDocumentProperty_GetPropertyName(self.Ptr, index))
        return ret



    def Remove(self ,name:str)->bool:
        """
    <summary>
        Remove a custom property associated with a specified name.
    </summary>
    <param name="name">Name of a custom property to remove.</param>
    <returns>Return true if a property was removed, false overwise.</returns>
        """
        
        namePtr = StrToPtr(name)
        GetDllLibPpt().IDocumentProperty_Remove.argtypes=[c_void_p ,c_char_p]
        GetDllLibPpt().IDocumentProperty_Remove.restype=c_bool
        ret = GetDllLibPpt().IDocumentProperty_Remove(self.Ptr,namePtr)
        return ret


    def Contains(self ,name:str)->bool:
        """
    <summary>
        Check presents of a custom property with a specified name.
    </summary>
    <param name="name">Name of a custom property to check.</param>
    <returns>Return true if property exists, false overwise.</returns>
        """
        
        namePtr = StrToPtr(name)
        GetDllLibPpt().IDocumentProperty_Contains.argtypes=[c_void_p ,c_char_p]
        GetDllLibPpt().IDocumentProperty_Contains.restype=c_bool
        ret = GetDllLibPpt().IDocumentProperty_Contains(self.Ptr,namePtr)
        return ret


    def get_Item(self ,name:str)->'SpireObject':
        """
    <summary>
        Gets or sets the custom property associated with a specified name.
            Read/write <see cref="T:System.Object" />.
    </summary>
        """
        
        namePtr = StrToPtr(name)
        GetDllLibPpt().IDocumentProperty_get_Item.argtypes=[c_void_p ,c_char_p]
        GetDllLibPpt().IDocumentProperty_get_Item.restype=c_void_p
        intPtr = GetDllLibPpt().IDocumentProperty_get_Item(self.Ptr,namePtr)
        ret = None if intPtr==None else SpireObject(intPtr)
        return ret



    def set_Item(self ,name:str,value:'SpireObject'):
        """

        """
        intPtrvalue:c_void_p = value.Ptr

        namePtr = StrToPtr(name)
        GetDllLibPpt().IDocumentProperty_set_Item.argtypes=[c_void_p ,c_char_p,c_void_p]
        GetDllLibPpt().IDocumentProperty_set_Item(self.Ptr,namePtr,intPtrvalue)

