from enum import Enum
from plum import dispatch
from typing import TypeVar,Union,Generic,List,Tuple
from spire.presentation.common import *
from spire.presentation import *
from ctypes import *
import abc

class KnownColors(Enum):
    """
    <summary>
        Represents predefined color presets.
    </summary>
    """
    none = -1
    AliceBlue = 0
    AntiqueWhite = 1
    Aqua = 2
    Aquamarine = 3
    Azure = 4
    Beige = 5
    Bisque = 6
    Black = 7
    BlanchedAlmond = 8
    Blue = 9
    BlueViolet = 10
    Brown = 11
    BurlyWood = 12
    CadetBlue = 13
    Chartreuse = 14
    Chocolate = 15
    Coral = 16
    CornflowerBlue = 17
    Cornsilk = 18
    Crimson = 19
    Cyan = 20
    DarkBlue = 21
    DarkCyan = 22
    DarkGoldenrod = 23
    DarkGray = 24
    DarkGreen = 25
    DarkKhaki = 26
    DarkMagenta = 27
    DarkOliveGreen = 28
    DarkOrange = 29
    DarkOrchid = 30
    DarkRed = 31
    DarkSalmon = 32
    DarkSeaGreen = 33
    DarkSlateBlue = 34
    DarkSlateGray = 35
    DarkTurquoise = 36
    DarkViolet = 37
    DeepPink = 38
    DeepSkyBlue = 39
    DimGray = 40
    DodgerBlue = 41
    Firebrick = 42
    FloralWhite = 43
    ForestGreen = 44
    Fuchsia = 45
    Gainsboro = 46
    GhostWhite = 47
    Gold = 48
    Goldenrod = 49
    Gray = 50
    Green = 51
    GreenYellow = 52
    Honeydew = 53
    HotPink = 54
    IndianRed = 55
    Indigo = 56
    Ivory = 57
    Khaki = 58
    Lavender = 59
    LavenderBlush = 60
    LawnGreen = 61
    LemonChiffon = 62
    LightBlue = 63
    LightCoral = 64
    LightCyan = 65
    LightGoldenrodYellow = 66
    LightGray = 67
    LightGreen = 68
    LightPink = 69
    LightSalmon = 70
    LightSeaGreen = 71
    LightSkyBlue = 72
    LightSlateGray = 73
    LightSteelBlue = 74
    LightYellow = 75
    Lime = 76
    LimeGreen = 77
    Linen = 78
    Magenta = 79
    Maroon = 80
    MediumAquamarine = 81
    MediumBlue = 82
    MediumOrchid = 83
    MediumPurple = 84
    MediumSeaGreen = 85
    MediumSlateBlue = 86
    MediumSpringGreen = 87
    MediumTurquoise = 88
    MediumVioletRed = 89
    MidnightBlue = 90
    MintCream = 91
    MistyRose = 92
    Moccasin = 93
    NavajoWhite = 94
    Navy = 95
    OldLace = 96
    Olive = 97
    OliveDrab = 98
    Orange = 99
    OrangeRed = 100
    Orchid = 101
    PaleGoldenrod = 102
    PaleGreen = 103
    PaleTurquoise = 104
    PaleVioletRed = 105
    PapayaWhip = 106
    PeachPuff = 107
    Peru = 108
    Pink = 109
    Plum = 110
    PowderBlue = 111
    Purple = 112
    Red = 113
    RosyBrown = 114
    RoyalBlue = 115
    SaddleBrown = 116
    Salmon = 117
    SandyBrown = 118
    SeaGreen = 119
    SeaShell = 120
    Sienna = 121
    Silver = 122
    SkyBlue = 123
    SlateBlue = 124
    SlateGray = 125
    Snow = 126
    SpringGreen = 127
    SteelBlue = 128
    Tan = 129
    Teal = 130
    Thistle = 131
    Tomato = 132
    Turquoise = 133
    Violet = 134
    Wheat = 135
    White = 136
    WhiteSmoke = 137
    Yellow = 138
    YellowGreen = 139

